'''
Script to set the URL for a HTTP request and trigger the POST Request
Ex:
/usr/bin/python3 /var/www/nebuleair_pro_4g/SARA/SSL/full_test_HTTP.py ttyAMA2 data.nebuleair.fr
To do: need to add profile id as parameter

First profile id:
    AT+UHTTP=0,1,"data.nebuleair.fr"
Second profile id:
    AT+UHTTP=1,1,"api-prod.uspot.probesys.net"
Third profile id:
    AT+UHTTP=2,1,"aircarto.fr"

'''

import serial
import time
import sys
import json

parameter = sys.argv[1:]  # Exclude the script name
#print("Parameters received:")
port='/dev/'+parameter[0] # ex: ttyAMA2
url = parameter[1]  # ex: data.mobileair.fr

profile_id = 3

baudrate = 115200
send_uSpot = False

def read_complete_response(serial_connection, timeout=2, end_of_response_timeout=2, wait_for_line=None):
    response = bytearray()
    serial_connection.timeout = timeout
    end_time = time.time() + end_of_response_timeout
    start_time = time.time()
 
    while True:
        elapsed_time = time.time() - start_time  # Time since function start
        if serial_connection.in_waiting > 0:
            data = serial_connection.read(serial_connection.in_waiting)
            response.extend(data)
            end_time = time.time() + end_of_response_timeout  # Reset timeout on new data

            # Decode and check for the specific line
            if wait_for_line:
                decoded_response = response.decode('utf-8', errors='replace')
                if wait_for_line in decoded_response:
                    print(f"[DEBUG] 🔎Found target line: {wait_for_line}")
                    break
        elif time.time() > end_time:
            print(f"[DEBUG] Timeout reached. No more data received.")
            break
        time.sleep(0.1)  # Short sleep to prevent busy waiting
    # Final response and debug output
    total_elapsed_time = time.time() - start_time
    print(f"[DEBUG] ⏱️ elapsed time: {total_elapsed_time:.2f}s. ⏱️")
    return response.decode('utf-8', errors='replace')

ser_sara = serial.Serial(
    port=port,  #USB0 or ttyS0
    baudrate=baudrate, #115200 ou 9600
    parity=serial.PARITY_NONE, #PARITY_NONE, PARITY_EVEN or PARITY_ODD
    stopbits=serial.STOPBITS_ONE,
    bytesize=serial.EIGHTBITS,
    timeout = 2
)



try:
   

    #step 4: set url (op_code = 1)
    print("****")
    print("SET URL")
    command = f'AT+UHTTP={profile_id},1,"{url}"\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_5 = read_complete_response(ser_sara)
    print(response_SARA_5)
    time.sleep(1)

    #step 4: set PORT (op_code = 5)
    print("****")
    print("SET PORT")
    command = f'AT+UHTTP={profile_id},5,80\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_55 = read_complete_response(ser_sara)
    print(response_SARA_55)
    time.sleep(1)


    #step 4: trigger the request
    print("****")
    print("Trigger POST REQUEST")
    command = f'AT+UHTTPC={profile_id},1,"/pro_4G/test.php","http.resp"\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_6 = read_complete_response(ser_sara, timeout=5, end_of_response_timeout=50, wait_for_line="+UUHTTPCR")

    print(response_SARA_6)
    time.sleep(1)

    #READ REPLY
    print("****")
    print("Read reply from server")
    ser_sara.write(b'AT+URDFILE="http.resp"\r')              
    response_SARA_7 = read_complete_response(ser_sara)        
    print("Reply from server:")
    print(response_SARA_7)


except serial.SerialException as e:
    print(f"Error: {e}")

finally:
    if ser_sara.is_open:
        ser_sara.close()
        print("****")
        #print("Serial closed")

